using CloudBuilder.Core.Authorization;
using CloudBuilder.Core.DatabaseAccessor.Entity;
using System.ComponentModel.DataAnnotations;
using System.ComponentModel.DataAnnotations.Schema;
namespace CloudBuilder.Security.Entity
 {
    [TypeScript]
    [Table("security_actor")]
    public class SecurityActorEntity : EntityBase<string>
    {

    public SecurityActorEntity() 
    {
    }

    [Column("created_datetime")]
    public DateTime CreatedDatetime  { get; set; }
    [Column("created_by")]
    public string CreatedBy  { get; set; }
    [Column("updated_datetime")]
    public DateTime UpdatedDatetime  { get; set; }
    [Column("updated_by")]
    public string UpdatedBy  { get; set; }
    [Key]
    [Column("actor_name")]
    public string ActorName  { get; set; }
    [Column("actor_local_name")]
    public string? ActorLocalName  { get; set; }
    [Column("actor_eng_name")]
    public string? ActorEngName  { get; set; }

    public const string CREATED_DATETIME = "CreatedDatetime";
    public const string CREATED_BY = "CreatedBy";
    public const string UPDATED_DATETIME = "UpdatedDatetime";
    public const string UPDATED_BY = "UpdatedBy";
    public const string ACTOR_NAME = "ActorName";
    public const string ACTOR_LOCAL_NAME = "ActorLocalName";
    public const string ACTOR_ENG_NAME = "ActorEngName";

    public const string DB_NAME_SECURITY_ACTOR = "security_actor";
    public const string DB_NAME_FIELDS="created_datetime,created_by,updated_datetime,updated_by,actor_name,actor_local_name,actor_eng_name";

    public const string DB_CREATED_DATETIME = "created_datetime";
    public const string DB_CREATED_BY = "created_by";
    public const string DB_UPDATED_DATETIME = "updated_datetime";
    public const string DB_UPDATED_BY = "updated_by";
    public const string DB_ACTOR_NAME = "actor_name";
    public const string DB_ACTOR_LOCAL_NAME = "actor_local_name";
    public const string DB_ACTOR_ENG_NAME = "actor_eng_name";


    public static SecurityActorEntity GetInstance()
    {
        return new SecurityActorEntity();
    }

    public virtual void CopyFrom(SecurityActorEntity source)
    {
        CopyFrom(source, true);
    }

    public virtual void CopyFrom(SecurityActorEntity source, bool includeSystemFields)
    {
        if (source == null)
        {
            throw new NullReferenceException("Source entity is null.");
        }

        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        this.ActorName =  source.ActorName;
        this.ActorLocalName =  source.ActorLocalName;
        this.ActorEngName =  source.ActorEngName;

        if (includeSystemFields)
        {
        this.CreatedDatetime =  source.CreatedDatetime;
        this.CreatedBy =  source.CreatedBy;
        this.UpdatedDatetime =  source.UpdatedDatetime;
        this.UpdatedBy =  source.UpdatedBy;
        }
    }

    public override string GetSelectFrom()
    {
        return $" select {DB_NAME_FIELDS} from { DB_NAME_SECURITY_ACTOR}  with(nolock) ";
    }
	
    public override string GetSelectCountFrom(string sqlWhere)
    {
        return $" select count(*) from { DB_NAME_SECURITY_ACTOR}  with(nolock) where 1=1 {sqlWhere}";
    }
	
    public override string GetSelectTopFrom(int limit, int start,string orderby,string orderbytag,  string sqlWhere)
    {
            if (string.IsNullOrEmpty(orderbytag)  || orderbytag.Trim() != "desc") orderbytag = "asc";
            if (string.IsNullOrEmpty(orderby) || !DB_NAME_FIELDS.Contains(orderby)) orderby =  DB_ACTOR_NAME ;  		
		string top = limit > 0 ? $"top {limit}" : "";
        return $" select {top} {DB_NAME_FIELDS} from (select {DB_NAME_FIELDS}  ,row_number() over(order by {orderby} {orderbytag}) as num from { DB_NAME_SECURITY_ACTOR}  with(nolock) where 1=1 {sqlWhere} ) a where num> {limit * (start - 1)}";
    }

    public SecurityActorEntity Clone()
    {
        SecurityActorEntity result = new SecurityActorEntity();
        result.CopyFrom(this);

        return result;
    }

    }
}
